"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } }

var _chunkERND2T7Pjs = require('./chunk-ERND2T7P.js');

// src/index.ts
var _unplugin = require('unplugin');
var _pluginutils = require('@rollup/pluginutils');
var _localpkg = require('local-pkg');
var _cores = require('unplugin-vue-define-options/cores');
function resolveOption(options) {
  let version = options.version;
  if (version === void 0) {
    const vuePkg = _localpkg.getPackageInfoSync.call(void 0, "vue");
    if (vuePkg) {
      version = +vuePkg.version.slice(0, 1);
    } else {
      version = 3;
    }
  }
  return {
    include: options.include || [/\.vue$/, /\.vue\?vue/],
    exclude: options.exclude || void 0,
    version,
    defineOptions: _nullishCoalesce(options.defineOptions, () => ( true)),
    defineModel: _nullishCoalesce(options.defineModel, () => ( true))
  };
}
var src_default = _unplugin.createUnplugin.call(void 0, (userOptions = {}) => {
  const options = resolveOption(userOptions);
  const filter = _pluginutils.createFilter.call(void 0, options.include, options.exclude);
  const name = "unplugin-vue-macros";
  return {
    name,
    enforce: "pre",
    transformInclude(id) {
      return filter(id);
    },
    transform(code, id) {
      try {
        let s;
        if (options.defineModel) {
          s = _chunkERND2T7Pjs.transformDefineModel.call(void 0, code, id, options.version);
        }
        if (options.defineOptions) {
          const newString = _cores.transform.call(void 0, code, id, s);
          if (newString)
            s || (s = newString);
        }
        if (!s)
          return;
        return {
          code: s.toString(),
          get map() {
            return s.generateMap();
          }
        };
      } catch (err) {
        this.error(`${name} ${err}`);
      }
    }
  };
});



exports.src_default = src_default;
