import {
  transformDefineModel
} from "./chunk-RLYSXNJM.mjs";

// src/index.ts
import { createUnplugin } from "unplugin";
import { createFilter } from "@rollup/pluginutils";
import { getPackageInfoSync } from "local-pkg";
import { transform } from "unplugin-vue-define-options/cores";
function resolveOption(options) {
  let version = options.version;
  if (version === void 0) {
    const vuePkg = getPackageInfoSync("vue");
    if (vuePkg) {
      version = +vuePkg.version.slice(0, 1);
    } else {
      version = 3;
    }
  }
  return {
    include: options.include || [/\.vue$/, /\.vue\?vue/],
    exclude: options.exclude || void 0,
    version,
    defineOptions: options.defineOptions ?? true,
    defineModel: options.defineModel ?? true
  };
}
var src_default = createUnplugin((userOptions = {}) => {
  const options = resolveOption(userOptions);
  const filter = createFilter(options.include, options.exclude);
  const name = "unplugin-vue-macros";
  return {
    name,
    enforce: "pre",
    transformInclude(id) {
      return filter(id);
    },
    transform(code, id) {
      try {
        let s;
        if (options.defineModel) {
          s = transformDefineModel(code, id, options.version);
        }
        if (options.defineOptions) {
          const newString = transform(code, id, s);
          if (newString)
            s || (s = newString);
        }
        if (!s)
          return;
        return {
          code: s.toString(),
          get map() {
            return s.generateMap();
          }
        };
      } catch (err) {
        this.error(`${name} ${err}`);
      }
    }
  };
});

export {
  src_default
};
